package com.izouma.dingdong.web.rider;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.rider.RiderLocation;
import com.izouma.dingdong.service.rider.RiderLocationService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.rider.RiderLocationRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/riderLocation")
@AllArgsConstructor
public class RiderLocationController extends BaseController {
    private RiderLocationService riderLocationService;
    private RiderLocationRepo riderLocationRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public RiderLocation save(@RequestBody RiderLocation record) {
        if (record.getId() != null) {
            RiderLocation orig = riderLocationRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return riderLocationRepo.save(orig);
        }
        return riderLocationRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<RiderLocation> all(PageQuery pageQuery) {
        return riderLocationRepo.findAll(toSpecification(pageQuery,RiderLocation.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public RiderLocation get(@PathVariable Long id) {
        return riderLocationRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        riderLocationRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<RiderLocation> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

